//+------------------------------------------------------------------+
//|                                                    CSV_to_GR.mq4 |
//|                                                        HomeWorks |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "HomeWorks"
#property link      "http://www.metaquotes.net"

//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
void start()
    {
    int q, r, record, q1, q2, q3, q4, q5, z, sgn, DIG[6];
                      // 1  2    3   4   5   6   7   8   9  10  11  12
    int max_day[13]={0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
    int y, m=0, d=0, hh, mm, ss, ss0;
                   //   0   1      2     3       4        5     6    7    8        9       10      11
                   //                ask  bid  Ask_Vol  Bid_Vol  Next_Line
    int delimiter[12]={46,  46,   32,   58,     58,      46,   44,  44,   44,     44,      44,     10};  //  
    double LG, ask0, bid0, V_a, V_b;
    string name, x, s2, DDTs, cat;
    bool receive[12], access;
    //---------------------------------------------------------------------------------------------
    s2=Symbol();
    cat=CharToStr(92)+"Recorder"+CharToStr(92);
  //name="USDJPY_Ticks_2012.10.06_2013.01.31.csv";
    //name="GBPUSD_Ticks_2012.01.01_2012.12.16.csv";
    //name="GBPUSD_Ticks_2012.01.01_2012.12.16.csv";
    name="USDCAD_Ticks_2012.02.01_2013.02.03.csv";
    q1=-1; z=20; while (q1==-1 && z>0) {q1=FileOpen(cat+s2+".ASK",FILE_BIN|FILE_READ|FILE_WRITE); z--;}
    q2=-1; z=20; while (q2==-1 && z>0) {q2=FileOpen(cat+s2+".BID",FILE_BIN|FILE_READ|FILE_WRITE); z--;}
    q3=-1; z=20; while (q3==-1 && z>0) {q3=FileOpen(cat+s2+".DAT",FILE_BIN|FILE_READ|FILE_WRITE); z--;}
    q4=-1; z=20; while (q4==-1 && z>0) {q4=FileOpen(cat+s2+".V_A",FILE_BIN|FILE_READ|FILE_WRITE); z--;} //volume Ask
    q5=-1; z=20; while (q5==-1 && z>0) {q5=FileOpen(cat+s2+".V_B",FILE_BIN|FILE_READ|FILE_WRITE); z--;} //volume Bid
    //------------------------------  -   -------------------------------------
    Print ("     CSV-...");
    q=FileOpen(name, FILE_BIN|FILE_READ);    //CSV-
    if (q!=-1)   // CSV
       {
       r=0; while (r!=10) r=FileReadInteger(q, 1);  //   CSV-, 10 -  ,     
       ArrayInitialize(DIG,0);
       hh=1000;                     //  1000 
       while (!FileIsEnding(q) && hh!=0)
             {
             x="";         //  
             ss=3;
             while (ss!=0)
                   {
                   r=FileReadInteger(q, 1);
                   if (ss==2 && r!=44) x=x+CharToStr(r);     //   
                   if ((r==44 && ss>1) || r==10) ss--;
                   }
             hh--;
             //---------------------------  x   -----------------------------
             z=StringLen(x);                   //     "76.24500"  lp=2
             for (ss=0; ss<z; ss++) if (StringSubstr(x, ss, 1)==".") {y=ss; if (ss!=z-1) break;}
             for (ss=z-1; ss>0; ss--) if (StringSubstr(x, ss, 1)!="0") {DIG[ss-y]++; if (ss!=1) break;}
             }
       FileClose(q);
       ss=0; for (r=1; r<6; r++) if (DIG[r]>ss) {ss=DIG[r]; sgn=r;}
       Print ("- =",sgn);
       }
    //-----------------------------------------------------------------------------------------------------------------
    q=FileOpen(name, FILE_BIN|FILE_READ);    //CSV-
    if (q!=-1)   // CSV
       {
       r=0;      //   CSV-
       while (r!=10) r=FileReadInteger(q, 1);             //10 -  ,     
       //-----------------------------------------------------------
       ArrayInitialize(receive, false);
       record=0;      //  -  Year
       x="";         //  
       DDTs="";     //       datetime
       ss=61;
       //---------------------------------------------------------//  2012.04.11
       access=true;
       //access=false;
       while (!FileIsEnding(q))
             {
             //if (m==4 && d==11) access=true; //break;
             r=FileReadInteger(q, 1);
             if (r==delimiter[record])   //  -   
                {
                //--------------------
                if (record<7) r=0; else if (record<9) r=sgn; else r=2;          //r=sgn -   
                LG=NormalizeDouble(StrToDouble(x),r);
                switch (record)
                       {
                       case 0: y=LG; DDTs=DDTs+x+"."; break;
                       case 1: m=LG; if (StringLen(x)!=2) x="0"+x; DDTs=DDTs+x+"."; break;
                       case 2: d=LG; if (StringLen(x)!=2) x="0"+x; DDTs=DDTs+x+" "; break;
                       case 3: hh=LG; if (StringLen(x)!=2) x="0"+x; DDTs=DDTs+x+":"; break;
                       case 4: mm=LG; if (StringLen(x)!=2) x="0"+x; DDTs=DDTs+x; break;
                       case 5: ss0=ss; ss=LG; break;
                       case 6:                  // datetime
                          if (LG>500)
                             {
                             ss++;
                             if (ss>60)
                                {
                                mm++;
                                if (mm>60)
                                   {
                                   hh++;
                                   if (hh>24)
                                      {
                                      d++;
                                      if (m==2 && d>28 && y%4==0 && (y%100!=0 || y%400==0)) max_day[2]=29; else max_day[2]=28;
                                      if (d>max_day[m])
                                         {
                                         m++;
                                         if (m>12)
                                            {
                                            y++;
                                            m=0;
                                            }
                                         d=0;
                                         }
                                      hh=0;
                                      }
                                   mm=0;
                                   }
                                ss=0;   //String value of date/time format as "yyyy.mm.dd hh:mi".
                                DDTs=DoubleToStr(y,0)+"."+DoubleToStr(m,0)+"."+DoubleToStr(d,0)+" "+DoubleToStr(hh,0)+":"+DoubleToStr(mm,0);
                                }//if (ss>60)
                             }//if (LG>500)
                          //-----------------
                          break; //case 6:
                       //----------------------------
                       case 7: ask0=LG; break;
                       case 8: bid0=LG; break;
                       case 9: if (ss<ss0) V_a=LG; break;
                       case 10:        //      
                          if (ss<ss0) V_b=LG;
                          //---------------------------------------------------
                       if (access) {
                          FileSeek(q1, 0, SEEK_END);   // 
                          FileWriteDouble (q1, ask0, DOUBLE_VALUE);
                          //---------------------------------------------------------
                          FileSeek(q2, 0, SEEK_END);   // 
                          FileWriteDouble (q2, bid0, DOUBLE_VALUE);
                          //---------------------------------------------------------
                          FileSeek(q3, 0, SEEK_END);   // 
                          FileWriteInteger(q3, StrToTime(DDTs)+ss, LONG_VALUE);
                          //--------------     M1 -----------------------------
                          FileSeek(q4, 0, SEEK_END);   // 
                          FileWriteDouble (q4, V_a, DOUBLE_VALUE);
                          //---------------------------------------------------
                          FileSeek(q5, 0, SEEK_END);   // 
                          FileWriteDouble (q5, V_b, DOUBLE_VALUE);
                          }//if (access)
                          DDTs="";
                          break;
                       case 11: record=-1; break;
                       default: break;
                       }//switch (j)
                //---------------------------------------------------
                record++;
                x="";
                }
                else x=x+CharToStr(r);
             //--------------------------
             }//while (!FileIsEnding(q))
       //---------------------------
       FileClose(q);
       }
    //--------------------
    FileClose(q1);
    FileClose(q2);
    FileClose(q3);
    FileClose(q4);
    FileClose(q5);
    PlaySound("alert.wav");
    return;
    }
//+------------------------------------------------------------------+