//+------------------------------------------------------------------+
//|                                                     Recorder.mq4 |
//|                                                        HomeWorks |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "HomeWorks"
#property link      ""

static int tick, q1, q2, q3;
static string s2;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
void init()
  {
  int z;
  string cat;
  //--------------------
  s2=Symbol();
  cat=CharToStr(92)+"Recorder"+CharToStr(92);
  //----------------------------
  q1=-1; z=20; while (q1==-1 && z>0) {q1=FileOpen(cat+s2+".ASK",FILE_BIN|FILE_READ|FILE_WRITE); z--;}
  q2=-1; z=20; while (q2==-1 && z>0) {q2=FileOpen(cat+s2+".BID",FILE_BIN|FILE_READ|FILE_WRITE); z--;}
  q3=-1; z=20; while (q3==-1 && z>0) {q3=FileOpen(cat+s2+".DAT",FILE_BIN|FILE_READ|FILE_WRITE); z--;}
  tick=0;
  return;
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
void deinit()
  {
  FileClose(q1);
  FileClose(q2);
  //FileSeek(q3, 0, SEEK_SET);   // 
  //FileWriteInteger(q3, tick, LONG_VALUE);
  FileClose(q3);
  return;
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
void start()
  {
  double ask0, bid0;
  //------------------------------------
  ask0=MarketInfo(s2, MODE_ASK);      // <0-; >0-
  bid0=MarketInfo(s2, MODE_BID);      // <0-; >0-
  //------------------------------------
  FileSeek(q1, 0, SEEK_END);   // 
  FileWriteDouble (q1, ask0, DOUBLE_VALUE);
  //------------------------------------
  FileSeek(q2, 0, SEEK_END);   // 
  FileWriteDouble (q2, bid0, DOUBLE_VALUE);
  //------------------------------------
  FileSeek(q3, 0, SEEK_END);   // 
  FileWriteInteger(q3, TimeLocal(), LONG_VALUE);
  //-----
  tick++;
  return;
  }
//+------------------------------------------------------------------+